/**
  This file is part of InfoVisTk

  Copyright (c) 2011 Bertjan Broeksema <broeksema@kde.org>

  InfoVisTk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/


#ifndef BENCHMARK_H
#define BENCHMARK_H

#include <QObject>

class Benchmark : public QObject
{
Q_OBJECT
public:
  explicit Benchmark(QObject *parent = 0);

private slots:
  // DPointer class tessts
  void testDPointerCreateDestruct();
  void testDPointerHeapCreateDestruct();
  void testDPointerCopy();
  void testDPointerAssignment();
  void testDPointerConstAccess();
  void testDPointerNonConstAccess();

  // Value class tests
  void testValueCreateDestruct();
  void testValueHeapCreateDestruct();
  void testValueCopy();
  void testValueAssignment();
  void testValueConstAccess();
  void testValueNonConstAccess();

  // Inline value class tests
  void testInlineValueCreateDestruct();
  void testInlineValueHeapCreateDestruct();
  void testInlineValueCopy();
  void testInlineValueAssignment();
  void testInlineValueConstAccess();
  void testInlineValueNonConstAccess();

};

#endif // BENCHMARK_H
