/**
  This file is part of InfoVisTk

  Copyright (c) 2011 Bertjan Broeksema <broeksema@kde.org>

  InfoVisTk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/


#include "dpointerclass.h"

struct DPointerClassPrivate
{
  int value;
};

DPointerClass::DPointerClass( int value )
  : d( new DPointerClassPrivate )
{
  d->value = value;
}

DPointerClass::DPointerClass( const DPointerClass &other )
  : d( new DPointerClassPrivate )
{
  *this = other;
}

DPointerClass::~DPointerClass()
{
  delete d;
}

DPointerClass &DPointerClass::operator=( const DPointerClass &other )
{
  if ( this == &other )
    return *this;

  d->value = other.d->value;
  return *this;
}

int DPointerClass::value() const
{
  return d->value;
}

void DPointerClass::setValue( int value )
{
  d->value = value;
}
